
proc checkmail {} {
	global news env

	update
	if { ![info exists news(pop3)] } { set news(pop3) "" }
	if { ![info exists news(popuser)] } { set news(popuser) "" }
	if { ![info exists news(poppass)] } { set news(poppass) "" }

	set ts [clock format [clock seconds] -format %H%M%S]

	if { $news(poppass) == "" } {
		set w [formwindow $ts passwd "Post Office Protocol - Version 3" "POP3 Server: " "POP3 User ID: " "Password: " ]
		$w.uf.f3.e configure -show "*"
		$w.ok configure -command "set news($w,wait) 1"
		bind $w.uf.f1.e <Key-Return> "$w.ok invoke"
		bind $w.uf.f2.e <Key-Return> "$w.ok invoke"
		bind $w.uf.f3.e <Key-Return> "$w.ok invoke"
		$w.cancel configure -command "set news($w,wait) 2"
		pack forget $w.f1

		if { $news(pop3) == "" } {
			if { [info exists news(mail)] } {
				set news($w,1) $news(mail)
			}
		} else {
			set news($w,1) $news(pop3)
		}
		if { $news(popuser) == "" } {
			if { [info exists news(email)] } {
				set news($w,2) [lindex [split $news(email) @ ] 0]
			}
		} else {
			set news($w,2) $news(popuser)
		}

		set news($w,3) $news(poppass)

		if { $news(pop3) == "" } {
			focus $w.uf.f1.e 
		} elseif { $news(popuser) == "" } {
			focus $w.uf.f2.e 
		} else   {
			focus $w.uf.f3.e 
		}


		set news($w,wait) 0

		tkwait variable news($w,wait)
		if { $news($w,wait) == 1 } {
			set news(pop3)  $news($w,1) 
			set news(popuser)  $news($w,2) 
			set news(poppass)  $news($w,3) 
		} 
		closewin $ts
	}
	if { $news(poppass) != "" } {
		set sock [socket $news(pop3) pop3]
		fconfigure $sock -translation crlf 
		fconfigure $sock -blocking off
		set head "From POPmail [clock format [clock seconds] %c]"

		# Check for a good connection
		set res [readsock $sock]
		set val [string range $res 0 2]
		if { $val != "+OK" } {
			closesocket $sock
			tk_dialog .xxerr "$news(tclnews) $news(version)" \
				"Can't connect to $news(pop3)!\nReceived ($res)." question 0 OK 
				return ""
		}
		socksend $sock "user $news(popuser)"
		set res [readsock $sock]
		set val [string range $res 0 2]
		if { $val != "+OK" } {
			closesocket $sock
			tk_dialog .xxerr "$news(tclnews) $news(version)" \
				"Bad user ID ($news(popuser))!\nReceived ($res)." question 0 OK 
				return ""
		}
		socksend $sock "pass $news(poppass)"
		set res [readsock $sock]
		set val [string range $res 0 2]
		if { $val != "+OK" } {
			closesocket $sock
			tk_dialog .xxerr "$news(tclnews) $news(version)" \
				"Can't logon as (Bad password)($news(popuser))!\nReceived ($res)." question 0 OK 
				return ""
		}
		# Now we're loged on.  See how many messages are there.
		socksend $sock "list"
		if { [rescode [readsock $sock] "+OK" "List Command Failed"] } {
			closesocket $sock
			return
		}
		set res [readsock $sock]
		set count 0;
		while { $res != "." } {
			set l [split $res] 
			set count [lindex $l 0]
			set mail($count) [lindex $l 1]
			set res [readsock $sock]
		}
		if { $count == 0 } {
			tk_dialog .xxerr "$news(tclnews) $news(version)" \
				"No new mail!" info 0 OK 
				return ""
		}
		if { [info exists env(MAIL)] } {
			set mailbox $env(MAIL)
		} elseif { [info env(LOGNAME)] } {
			set mailbox /usr/spool/mail/$env(LOGNAME)
		}

		set fd [open $mailbox a+]
	
		#  Get a time stamp for the Window name
		set nts [clock format [clock seconds] -format %H%M%S]
		set w ".$nts"
		set txt "G$nts"
		toplevel $w
		wm geometry $w $news(dnload,geo)
		bind $w <Configure> "setgeo $w %W dnload"
		scale $w.s -from 1 -to $mail(1)  -variable news($w,scale)  -label "Getting New Mail"\
			-showvalue true -orient horizontal -length 400 -state disabled
		pack $w.s
		for {set m 1} { $m <= $count} {incr m} {
			set news($w,scale) 0
			$w.s configure -to $mail($m)  -label "Getting New Mail $m of $count ($mail($m))"
			socksend $sock "retr $m"
			if { [rescode [readsock $sock] +OK "retr $m"] } {
				closewin $nts
				closesocket $sock
				return
			}
			update
			
			set res [readsock $sock]
			puts $fd $head
			set news($w,scale) 0
			set size 0
			while { $res != "." } {
				incr size [string length $res]
				incr news($w,scale) $size
				update
				puts $fd $res
				set res [readsock $sock]
			}
			socksend $sock "dele $m"
			if { [rescode [readsock $sock] +OK "dele $m"] } {
				closewin $nts
				closesocket $sock
				return
			}
			update
		}
		socksend $sock "quit"
		close $fd
		closewin $nts
		closesocket $sock
		tk_dialog .xxerr "$news(tclnews) $news(version)" "New mail has arrived" info 0 OK 
	}
}

